// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'ImageEnIO.pas' rev: 3.00

#ifndef ImageEnIOHPP
#define ImageEnIOHPP
#include <iedefs.hpp>
#include <ExtCtrls.hpp>
#include <ImageEnProc.hpp>
#include <ImageEnView.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Imageenio
{
//-- type declarations -------------------------------------------------------
struct TStreamJpegHeader
{
	char ID[5];
	int dim;
} ;

struct TJpegHeader
{
	Word SOImarker;
	Word APPOmarker;
	Word Len;
	char Id[5];
} ;

struct PCXSHead
{
	char ID[5];
	int dim;
} ;

struct TIFFSHead
{
	char ID[5];
	int dim;
} ;

enum ImageEnIO__1 { ppAll, ppJPEG, ppTIFF, ppGIF, ppBMP, ppPCX };

typedef Set<ImageEnIO__1, ppAll, ppPCX>  TPreviewParams;

typedef void __fastcall (*TGIFLZWCompFunc)(Classes::TStream* Stream, int Height, int Width, bool Interlaced
	, char * FData, int BitsPerPixel);

typedef void __fastcall (*TGIFLZWDecompFunc)(Classes::TStream* Stream, int Height, int Width, bool Interlaced
	, char * FData);

typedef Windows::PByte __fastcall (*TTIFFLZWDecompFunc)(Windows::PByte CompBuf, int LineSize, int &Id
	);

enum TIOPreviewsParamsItems { ioppDefaultLockPreview };

typedef Set<TIOPreviewsParamsItems, ioppDefaultLockPreview, ioppDefaultLockPreview>  TIOPreviewsParams
	;

enum TIOTIFFCompression { ioTIFF_UNCOMPRESSED, ioTIFF_CCITT1D, ioTIFF_G3FAX1D, ioTIFF_G3FAX2D, ioTIFF_G4FAX, 
	ioTIFF_LZW, ioTIFF_OLDJPEG, ioTIFF_JPEG, ioTIFF_PACKBITS };

enum TIOTIFFPhotometInterpret { ioTIFF_WHITEISZERO, ioTIFF_BLACKISZERO, ioTIFF_RGB, ioTIFF_RGBPALETTE, 
	ioTIFF_TRANSPMASK, ioTIFF_CMYK, ioTIFF_YCBCR, ioTIFF_CIELAB };

enum TIOJPEGColorspace { ioJPEG_RGB, ioJPEG_GRAYLEV };

enum TIOJPEGDctMethod { ioJPEG_ISLOW, ioJPEG_IFAST, ioJPEG_FLOAT };

enum TIOBMPVersion { ioBMP_BM, ioBMP_BM3, ioBMP_BMOS2V1, ioBMP_BMOS2V2 };

enum TIOBMPCompression { ioBMP_UNCOMPRESSED, ioBMP_RLE };

enum TIOPCXCompression { ioPCX_UNCOMPRESSED, ioPCX_RLE };

class DELPHICLASS TIOParamsVals;
class DELPHICLASS TImageEnIO;
class PASCALIMPLEMENTATION TImageEnIO : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Graphics::TBitmap* fBitmap;
	Imageenview::TImageEnView* fImageEnView;
	Extctrls::TImage* fTImage;
	Graphics::TColor fBackground;
	Iedefs::TProgressEvent fOnProgress;
	TMsgLanguage fMsgLanguage;
	TIOPreviewsParams fPreviewsParams;
	TIOParamsVals* fParams;
	bool fStreamHeaders;
	Graphics::TFont* fPreviewFont;
	void __fastcall SetAttachedBitmap(Graphics::TBitmap* atBitmap);
	void __fastcall SetAttachedImageEn(Imageenview::TImageEnView* atImageEn);
	Graphics::TColor __fastcall GetReBackground(void);
	void __fastcall SetReBackground(Graphics::TColor v);
	void __fastcall Clear(void);
	void __fastcall SetPreviewFont(Graphics::TFont* f);
	void __fastcall SetTImage(Extctrls::TImage* v);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	
public:
	__fastcall virtual TImageEnIO(Classes::TComponent* Owner);
	__fastcall virtual ~TImageEnIO(void);
	__property Graphics::TBitmap* AttachedBitmap = {read=fBitmap, write=SetAttachedBitmap};
	void __fastcall Update(void);
	bool __fastcall DoPreviews(TPreviewParams pp);
	__property Graphics::TBitmap* Bitmap = {read=fBitmap};
	__property TIOParamsVals* Params = {read=fParams};
	void __fastcall AssignParams(System::TObject* Source);
	void __fastcall SaveToFileJpeg(const System::AnsiString nf);
	void __fastcall LoadFromFileJpeg(const System::AnsiString nf);
	void __fastcall SaveToStreamJpeg(Classes::TStream* Stream);
	void __fastcall LoadFromStreamJpeg(Classes::TStream* Stream);
	int __fastcall LoadFromFileGif(const System::AnsiString nf);
	void __fastcall SaveToFileGif(const System::AnsiString nf);
	int __fastcall InsertToGif(const System::AnsiString nf);
	int __fastcall LoadFromStreamGif(Classes::TStream* Stream);
	void __fastcall SaveToStreamGif(Classes::TStream* Stream);
	void __fastcall SaveToStreamPCX(Classes::TStream* Stream);
	void __fastcall LoadFromStreamPCX(Classes::TStream* Stream);
	void __fastcall SaveToFilePCX(const System::AnsiString nf);
	void __fastcall LoadFromFilePCX(const System::AnsiString nf);
	int __fastcall LoadFromStreamTIFF(Classes::TStream* Stream);
	void __fastcall SaveToStreamTIFF(Classes::TStream* Stream);
	int __fastcall LoadFromFileTIFF(const System::AnsiString nf);
	void __fastcall SaveToFileTIFF(const System::AnsiString nf);
	void __fastcall SaveToStreamBMP(Classes::TStream* Stream);
	void __fastcall LoadFromStreamBMP(Classes::TStream* Stream);
	void __fastcall SaveToFileBMP(const System::AnsiString nf);
	void __fastcall LoadFromFileBMP(const System::AnsiString nf);
	void __fastcall LoadFromFileICO(const System::AnsiString nf);
	void __fastcall LoadFromFileCUR(const System::AnsiString nf);
	void __fastcall LoadFromFile(const System::AnsiString nf);
	void __fastcall SaveToFile(const System::AnsiString nf);
	bool __fastcall Acquire(void);
	void __fastcall SelectAcquireSource(void);
	
__published:
	__property Imageenview::TImageEnView* AttachedImageEn = {read=fImageEnView, write=SetAttachedImageEn
		};
	__property Graphics::TColor Background = {read=GetReBackground, write=SetReBackground, default=0};
	__property Iedefs::TProgressEvent OnProgress = {read=fOnProgress, write=fOnProgress};
	__property Iedefs::TMsgLanguage MsgLanguage = {read=fMsgLanguage, write=fMsgLanguage, default=0};
	__property TIOPreviewsParams PreviewsParams = {read=fPreviewsParams, write=fPreviewsParams, default=0
		};
	__property bool StreamHeaders = {read=fStreamHeaders, write=fStreamHeaders, default=1};
	__property Graphics::TFont* PreviewFont = {read=fPreviewFont, write=SetPreviewFont};
	__property Extctrls::TImage* AttachedTImage = {read=fTImage, write=SetTImage};
};

class PASCALIMPLEMENTATION TIOParamsVals : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TImageEnIO* fImageEnIO;
	int fBitsPerSample;
	int fSamplesPerPixel;
	int fDpiX;
	int fDpiY;
	TIOTIFFCompression fTIFF_Compression;
	int fTIFF_ImageIndex;
	TIOTIFFPhotometInterpret fTIFF_PhotometInterpret;
	int fTIFF_PlanarConf;
	int fTIFF_XPos;
	int fTIFF_YPos;
	System::AnsiString fTIFF_DocumentName;
	System::AnsiString fTIFF_ImageDescription;
	System::AnsiString fTIFF_PageName;
	int fTIFF_PageNumber;
	int fTIFF_PageCount;
	TTIFFLZWDecompFunc fTIFF_LZWDecompFunc;
	System::AnsiString fGIF_Version;
	int fGIF_ImageIndex;
	int fGIF_XPos;
	int fGIF_YPos;
	int fGIF_DelayTime;
	bool fGIF_FlagTranspColor;
	Iedefs::TRGB fGIF_TranspColor;
	bool fGIF_Interlaced;
	int fGIF_WinWidth;
	int fGIF_WinHeight;
	Iedefs::TRGB fGIF_Background;
	int fGIF_Ratio;
	TGIFLZWDecompFunc fGIF_LZWDecompFunc;
	TGIFLZWCompFunc fGIF_LZWCompFunc;
	TIOJPEGColorspace fJPEG_ColorSpace;
	int fJPEG_Quality;
	TIOJPEGDctMethod fJPEG_DCTMethod;
	bool fJPEG_OptimalHuffman;
	int fJPEG_Smooth;
	bool fJPEG_Progressive;
	int fPCX_Version;
	TIOPCXCompression fPCX_Compression;
	TIOBMPVersion fBMP_Version;
	TIOBMPCompression fBMP_Compression;
	int fICO_WIDTH;
	int fICO_HEIGHT;
	int fCUR_WIDTH;
	int fCUR_HEIGHT;
	
public:
	System::AnsiString fFileName;
	int fWidth;
	int fHeight;
	Iedefs::RGBROW *fColorMap;
	int fColorMapCount;
	__property System::AnsiString FileName = {read=fFileName};
	__property int BitsPerSample = {read=fBitsPerSample, write=fBitsPerSample, nodefault};
	__property int SamplesPerPixel = {read=fSamplesPerPixel, write=fSamplesPerPixel, nodefault};
	__property int Width = {read=fWidth, nodefault};
	__property int Height = {read=fHeight, nodefault};
	__property int DpiX = {read=fDpiX, write=fDpiX, nodefault};
	__property int DpiY = {read=fDpiY, write=fDpiY, nodefault};
	__property Iedefs::pRGBROW ColorMap = {read=fColorMap};
	__property int ColorMapCount = {read=fColorMapCount, nodefault};
	__property TIOTIFFCompression TIFF_Compression = {read=fTIFF_Compression, write=fTIFF_Compression, 
		nodefault};
	__property int TIFF_ImageIndex = {read=fTIFF_ImageIndex, write=fTIFF_ImageIndex, nodefault};
	__property TIOTIFFPhotometInterpret TIFF_PhotometInterpret = {read=fTIFF_PhotometInterpret, write=fTIFF_PhotometInterpret
		, nodefault};
	__property int TIFF_PlanarConf = {read=fTIFF_PlanarConf, write=fTIFF_PlanarConf, nodefault};
	__property int TIFF_XPos = {read=fTIFF_XPos, write=fTIFF_XPos, nodefault};
	__property int TIFF_YPos = {read=fTIFF_YPos, write=fTIFF_YPos, nodefault};
	__property System::AnsiString TIFF_DocumentName = {read=fTIFF_DocumentName, write=fTIFF_DocumentName
		};
	__property System::AnsiString TIFF_ImageDescription = {read=fTIFF_ImageDescription, write=fTIFF_ImageDescription
		};
	__property System::AnsiString TIFF_PageName = {read=fTIFF_PageName, write=fTIFF_PageName};
	__property int TIFF_PageNumber = {read=fTIFF_PageNumber, write=fTIFF_PageNumber, nodefault};
	__property int TIFF_PageCount = {read=fTIFF_PageCount, write=fTIFF_PageCount, nodefault};
	__property TTIFFLZWDecompFunc TIFF_LZWDecompFunc = {read=fTIFF_LZWDecompFunc, write=fTIFF_LZWDecompFunc
		};
	__property System::AnsiString GIF_Version = {read=fGIF_Version, write=fGIF_Version};
	__property int GIF_ImageIndex = {read=fGIF_ImageIndex, write=fGIF_ImageIndex, nodefault};
	__property int GIF_XPos = {read=fGIF_XPos, write=fGIF_XPos, nodefault};
	__property int GIF_YPos = {read=fGIF_YPos, write=fGIF_YPos, nodefault};
	__property int GIF_DelayTime = {read=fGIF_DelayTime, write=fGIF_DelayTime, nodefault};
	__property bool GIF_FlagTranspColor = {read=fGIF_FlagTranspColor, write=fGIF_FlagTranspColor, nodefault
		};
	__property Iedefs::TRGB GIF_TranspColor = {read=fGIF_TranspColor, write=fGIF_TranspColor};
	__property bool GIF_Interlaced = {read=fGIF_Interlaced, write=fGIF_Interlaced, nodefault};
	__property int GIF_WinWidth = {read=fGIF_WinWidth, write=fGIF_WinWidth, nodefault};
	__property int GIF_WinHeight = {read=fGIF_WinHeight, write=fGIF_WinHeight, nodefault};
	__property Iedefs::TRGB GIF_Background = {read=fGIF_Background, write=fGIF_Background};
	__property int GIF_Ratio = {read=fGIF_Ratio, write=fGIF_Ratio, nodefault};
	__property TGIFLZWDecompFunc GIF_LZWDecompFunc = {read=fGIF_LZWDecompFunc, write=fGIF_LZWDecompFunc
		};
	__property TGIFLZWCompFunc GIF_LZWCompFunc = {read=fGIF_LZWCompFunc, write=fGIF_LZWCompFunc};
	__property TIOJPEGColorspace JPEG_ColorSpace = {read=fJPEG_ColorSpace, write=fJPEG_ColorSpace, nodefault
		};
	__property int JPEG_Quality = {read=fJPEG_Quality, write=fJPEG_Quality, nodefault};
	__property TIOJPEGDctMethod JPEG_DCTMethod = {read=fJPEG_DCTMethod, write=fJPEG_DCTMethod, nodefault
		};
	__property bool JPEG_OptimalHuffman = {read=fJPEG_OptimalHuffman, write=fJPEG_OptimalHuffman, nodefault
		};
	__property int JPEG_Smooth = {read=fJPEG_Smooth, write=fJPEG_Smooth, nodefault};
	__property bool JPEG_Progressive = {read=fJPEG_Progressive, write=fJPEG_Progressive, nodefault};
	__property int PCX_Version = {read=fPCX_Version, write=fPCX_Version, nodefault};
	__property TIOPCXCompression PCX_Compression = {read=fPCX_Compression, write=fPCX_Compression, nodefault
		};
	__property TIOBMPVersion BMP_Version = {read=fBMP_Version, write=fBMP_Version, nodefault};
	__property TIOBMPCompression BMP_Compression = {read=fBMP_Compression, write=fBMP_Compression, nodefault
		};
	__property int ICO_Width = {read=fICO_WIDTH, write=fICO_WIDTH, nodefault};
	__property int ICO_Height = {read=fICO_HEIGHT, write=fICO_HEIGHT, nodefault};
	__property int CUR_Width = {read=fCUR_WIDTH, write=fCUR_WIDTH, nodefault};
	__property int CUR_Height = {read=fCUR_HEIGHT, write=fCUR_HEIGHT, nodefault};
	__fastcall TIOParamsVals(TImageEnIO* IEIO);
	__fastcall virtual ~TIOParamsVals(void);
	void __fastcall SetDefaultParams(void);
	void __fastcall Assign(TIOParamsVals* Source);
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE int __fastcall DeleteGifIm(const System::AnsiString nf, int idx);
extern PACKAGE int __fastcall DeleteTIFFIm(const System::AnsiString nf, int idx);
extern PACKAGE int __fastcall EnumGifIm(const System::AnsiString nf);
extern PACKAGE int __fastcall EnumTIFFIm(const System::AnsiString nf);
extern PACKAGE bool __fastcall CheckAniGif(const System::AnsiString nf);
extern PACKAGE System::AnsiString __fastcall FindFileFormat(const System::AnsiString nf);
extern PACKAGE System::AnsiString __fastcall FindStreamFormat(Classes::TStream* fs);

}	/* namespace Imageenio */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Imageenio;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// ImageEnIO
